signature TYPE =
sig

  type var = int

  datatype tp =				(* A ::= *)
      Var of int			(* 'n, n >= 1 *)
    | Tensor of tp * tp			(* A1 # A2 *)
    | One				(* 1 *)
    | Lolli of tp * tp			(* A1 -o A2 *)
    | With of tp * tp			(* A1 & A2 *)
    | Top				(* T *)
    | Plus of tp * tp			(* A1 + A2 *)
    | Zero				(* 0 *)
    | Arrow of tp * tp			(* A1 -> A2 *)
    | Bang of tp			(* !A *)
    | Mu of tp				(* mu 'a. A *)

  (* eq(A,A') = true iff A = A' *)
  val eq : tp * tp -> bool

  (* subst(A,B) = [A/'a]B, where 'a represents the free de Bruijn *)
  (* index '1.  A must be closed and B must have exactly one free variable *)
  val subst : tp * tp -> tp

end;  (* signature TYPE *)
